\documentclass[../t19_ME401_Midterm.tex]{subfiles}
\begin{document}
    \section{Machine States}\label{sec:states}
    \subsection{State Transition Criteria}\label{subsec:stateTransition}
        \begin{figure}[htbp]
            \centering
            \includegraphics[width=0.8\textwidth]{Images/stateDiagram.png}
            \caption[State Transition Diagram]{Machine state transition diagram}
            \label{fig:stateDiagram}
        \end{figure}
        \subsubsection{State Transition}
        \begin{itemize}
            \item \textbf{Zombie $\rightarrow$ Healthy:} The Zombie robot must be touched by a Healing robot. 
            \item \textbf{Healthy $\rightarrow$ Zombie:} The Healthy robot must be touched by the Zombie robot. 
            \item \textbf{Healthy $\rightarrow$ Healing:} The Healthy robot needs to pick up one of the balls placed on the field. 
            \item \textbf{Healing $\rightarrow$ Healthy:} The Healing robot will return to the Healthy state after healing a Zombie robot.
        \end{itemize}

    \subsection{Zombie State}\label{subsec:zombie}
        While in the Zombie State the robot will read in information from an IR distance sensor. This sensor will be attached to a DC motor so that the IR distance sensor can scan a wider area. The robot will then read in the distance of the object to determine where the other robot in play is. Our robot will then drive toward the sited robot while it continues to scan in order to follow other robots. 

        In the Zombie state we were not allowed to us the information that was relayed over the radio from the camera we had to us an IR distance sensor attached to a DC motor. Because of this, while in the Zombie state our robot will not be able to differentiate between Zombies and Healthy robots. In the Zombie state our robot will chase all other robots. 

        During this state the DC motor starts 60 degrees to the right of center. The motor then sweeps to 60 degrees to the left of center. This creates a total 120 degrees sweep. During this sweep the IR distance sensor will take 10 total reading. That is, a reading every 12 degrees. The code records the angle of the motor associated with the smallest distance reading. The robot then turns towards the associated angle until it is zero, meaning the targeted object is directly ahead of the robot. A proportional gain is used to decrease the rotational speed as the robot approaches the target angle. 
    
        When the sensor sees another robot both the distance of the robot and the angle of the DC motor. Our robot will then drive toward that spot. Also, the robot will continue to scan for the other robot. This is so that our robot while in zombie mode will be able to track the sited robot. 
    

    \subsection{Healthy State}\label{subsec:healthy}
        While in the Healthy State the robot will be able to use the information from the overhead camera to determine both its position, the position of the balls, and the positions of other robots on the field. The camera information will be read in over a radio signal. This signal will relay the ID number, position, and state of the other robots on the field. It will also give the position of the balls on the field as well. From this information our robot will determine whether a ball or Zombie is closest to it. Once that is determined the robot will ether drive away from the Zombie or toward the ball. 

    \subsection{Healing State}\label{subsec:healing}
        While in the Healing State the robot will be able to use the use the information from the camera to determine the position of the Zombie robots in the field. This information will be read in using the radio signal from the camera. From that information our robot will determine the closest Zombie to it. Once that Zombie is found our robot will chase after that Zombie in order to heal it.
        
    % \subsection{Zombie State Explanation}\label{subsec:zombieExtra}

        % In the Zombie state we were not allowed to us the information that was relayed over the radio from the camera we had to us an IR distance sensor attached to a DC motor. Because of this, while in the Zombie state our robot will not be able to differentiate between Zombies and Healthy robots. In the Zombie state our robot will chase all other robots. 

        % During this state the DC motor starts 60 degrees to the right of center. The motor then sweeps to 60 degrees to the left of center. This creates a total 120 degrees sweep. During this sweep the IR distance sensor will take 10 total reading. That is, a reading every 12 degrees. The code records the angle of the motor associated with the smallest distance reading. The robot then turns towards the associated angle until it is zero, meaning the targeted object is directly ahead of the robot. A proportional gain is used to decrease the rotational speed as the robot approaches the target angle. 
    
        % When the sensor sees another robot both the distance of the robot and the angle of the DC motor. Our robot will then drive toward that spot. Also, the robot will continue to scan for the other robot. This is so that our robot while in zombie mode will be able to track the sited robot. 
    


\end{document}